# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S). Our API is RESTful. It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. You can use your favorite HTTP/REST library for your programming language to use PeerTube. No official SDK is currently provided, but the spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class RegisterUser(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'username': 'str',
        'password': 'str',
        'email': 'str',
        'display_name': 'str',
        'channel': 'RegisterUserChannel'
    }

    attribute_map = {
        'username': 'username',
        'password': 'password',
        'email': 'email',
        'display_name': 'displayName',
        'channel': 'channel'
    }

    def __init__(self, username=None, password=None, email=None, display_name=None, channel=None, local_vars_configuration=None):  # noqa: E501
        """RegisterUser - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._username = None
        self._password = None
        self._email = None
        self._display_name = None
        self._channel = None
        self.discriminator = None

        self.username = username
        self.password = password
        self.email = email
        if display_name is not None:
            self.display_name = display_name
        if channel is not None:
            self.channel = channel

    @property
    def username(self):
        """Gets the username of this RegisterUser.  # noqa: E501

        The username of the user   # noqa: E501

        :return: The username of this RegisterUser.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this RegisterUser.

        The username of the user   # noqa: E501

        :param username: The username of this RegisterUser.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and username is None:  # noqa: E501
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this RegisterUser.  # noqa: E501

        The password of the user   # noqa: E501

        :return: The password of this RegisterUser.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this RegisterUser.

        The password of the user   # noqa: E501

        :param password: The password of this RegisterUser.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and password is None:  # noqa: E501
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def email(self):
        """Gets the email of this RegisterUser.  # noqa: E501

        The email of the user   # noqa: E501

        :return: The email of this RegisterUser.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this RegisterUser.

        The email of the user   # noqa: E501

        :param email: The email of this RegisterUser.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and email is None:  # noqa: E501
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def display_name(self):
        """Gets the display_name of this RegisterUser.  # noqa: E501

        The user display name  # noqa: E501

        :return: The display_name of this RegisterUser.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this RegisterUser.

        The user display name  # noqa: E501

        :param display_name: The display_name of this RegisterUser.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def channel(self):
        """Gets the channel of this RegisterUser.  # noqa: E501


        :return: The channel of this RegisterUser.  # noqa: E501
        :rtype: RegisterUserChannel
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this RegisterUser.


        :param channel: The channel of this RegisterUser.  # noqa: E501
        :type: RegisterUserChannel
        """

        self._channel = channel

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegisterUser):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RegisterUser):
            return True

        return self.to_dict() != other.to_dict()
